(function() {
  describe("iframe editor", function() {
    var $inputor, app;
    $inputor = null;
    app = null;
    beforeEach(function() {
      var ifr, ifrBody;
      loadFixtures("inputors.html");
      ifr = $('#iframeInput')[0];
      ifrBody = ifr.contentDocument.body;
      ifrBody.contentEditable = true;
      ifrBody.id = 'ifrBody';
      ifrBody.innerHTML = 'Stay Foolish, Stay Hungry. @Jobs';
      $inputor = $(ifrBody);
      $inputor.atwho('setIframe', ifr);
      $inputor.atwho({
        at: "@",
        data: ['Jobs']
      });
      return app = getAppOf($inputor);
    });
    it("can insert content", function() {
      triggerAtwhoAt($inputor);
      return expect($inputor.text()).toContain('@Jobs');
    });
    return it("insert by click", function() {
      simulateTypingIn($inputor);
      app.controller().view.$el.find('ul').children().first().trigger('click');
      return expect($inputor.text()).toContain('@Jobs');
    });
  });

}).call(this);
